import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int[] a = new int[n];

        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }

        Arrays.sort(a);
        int count = 0;

        while (a.length > 0) {
            int s = a[a.length - 1];
            a = del(a, a.length - 1);

            for (int i = a.length - 1; i >= 0; i--) {
                if (s > a[i]) {
                    s = a[i];
                    a = del(a, i);
                    i = a.length - 1;
                }
            }

            count++;
        }

        out.println(count);
        out.close();
    }

    static int[] del (int[] a, int i) {
        int[] b = new int[a.length - 1];

        for (int j = 0; j < a.length; j++) {
            if (j < i) {
                b[j] = a[j];
            } else if (j > i) {
                b[j - 1] = a[j];
            }
        }

        return b;
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}