import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int[] a = new int[n];

        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }

        int[] b = new int[n * n];

        for (int i = 0; i < n * n; i++) {

            b[i] = Math.abs(a[i / n] - a[i % n]);
        }

        int m = b[0];

        for (int i = 1; i < b.length; i++) {
            m = nod(m, b[i]);
        }

        out.println(m);
        out.close();
    }

    static int nod (int x, int y) {
        int a = Math.max(x, y);
        int b = Math.min(x, y);

        if (a == 0) {
            return b;
        }

        if (b == 0) {
            return a;
        }

        while (a % b != 0) {
            int s = b;
            b = a % b;
            a = s;
        }

        return b;
    }


    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}