import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) throws IOException {
        int n = nextInt();

        int[] a = new int[n];

        for (int i = 0; i < n; i++) {
            a[i] = nextInt() - 1;
        }

        boolean[] visit = new boolean[n];
        int tru = 0;

        StringBuilder bigS = new StringBuilder();

        while (tru < n) {
            StringBuilder stb = new StringBuilder();
            int j = -1;
            for (int i = 0; i < n; i++) {
                if (!visit[i]) {
                    stb.append(i + 1);
                    visit[i] = true;
                    j = i;
                    tru++;
                    break;
                }
            }

            while (true) {
                if (!visit[a[j]]) {
                    j = a[j];
                    visit[j] = true;
                    tru++;
                    stb.append(j + 1);
                } else {
                    bigS.append(stb).append("/");
                    break;
                }
            }
        }

        bigS.delete(bigS.length() - 1, bigS.length());

        String[] svyaz = bigS.toString().split("/");
        int[][] ab = new int[svyaz.length][];
        int count = 0;

//        out.println(bigS);

        for (int i = 0; i < ab.length; i++) {
            ab[i] = new int[svyaz[i].length()];
            for (int j = 0; j < svyaz[i].length(); j++) {
                ab[i][j] = svyaz[i].charAt(j) - 48;
            }
            if (ab[i].length % 2 != 0) {
                count++;
            }
        }

        out.println(count);

        int[] a1 = new int[(n - count) / 2];
        int[] a2 = new int[(n - count) / 2];
        int i1 = 0;
        int i2 = 0;

        for (int i = 0; i < ab.length; i++) {
            for (int j = 1; j < ab[i].length; j += 2) {
                a1[i / 2 + i1] = ab[i][j];
                i1++;
                a2[i / 2 + i2] = ab[i][j - 1];
                i2++;
            }
        }

        for (int i = 0; i < a1.length; i++) {
            out.print(a1[i] + " ");
        }

        out.println();

        for (int i = 0; i < a2.length; i++) {
            out.print(a2[i] + " ");
        }

        out.close();
    }


    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}