import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long t = nextLong();
        long[] a = new long[n + 1];
        a[0] = 0;

        for (int i = 1; i < n + 1; i++) {
            a[i] = a[i - 1] + nextInt();
        }


        int k = 1;
        int l = n;

        for (int j = k; j < n + 1; j++) {
            if (a[j] - a[j - k] > t) {
                out.println(k);
                out.close();
                return;
            }
        }


        if (a[n] - a[0] <= t) {
            out.println(-1);
            out.close();
            return;
        }


        while (l - k > 1) {
            int kl = (k + l)/2;
            boolean bool = true;
            for (int j = kl; j < n + 1; j++) {
                if (a[j] - a[j - kl] > t) {
                    l = kl;
                    bool = false;
                    break;
                }
            }
            if (bool) {
                k = kl;
            }
        }

        out.println(l);

        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}