import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        char[][] a = new char[n][m - 1];
        char[][] b = new char[n - 1][m];

        for (int i = 0; i < n; i++) {
            String st = br.readLine();
            for (int j = 0; j < m - 1; j++) {
                a[i][j] = st.charAt(j);
            }
        }

        for (int i = 0; i < n - 1; i++) {
            String st = br.readLine();
            for (int j = 0; j < m; j++) {
                b[i][j] = st.charAt(j);
            }
        }

        int q = nextInt();

        for (int i = 0; i < q; i++) {
            int x1 = nextInt() - 1;
            int y1 = nextInt() - 1;
            int x2 = nextInt() - 1;
            int y2 = nextInt() - 1;

            if (x1 == x2 || y1 == y2) {
                out.println(1);
            } else {
                out.println(2);
            }
        }

        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}