import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int[] a = new int[n];

        if (n == 0) {
            out.println(0);
            out.close();
            return;
        }

        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }

        Arrays.sort(a);
        int count = 1;
        int tru = 0;

        boolean[] b = new boolean[n];

        for (int i = 0; i < n; i++) {
            b[i] = false;
        }

        int s = a[a.length - 1];
        b[a.length - 1] = true;
        tru++;

        while (tru < n) {
            for (int i = a.length - 1; i >= 0; i--) {
                if (s > a[i] && !b[i]) {
                    s = a[i];
                    b[i] = true;
                    tru++;
                    count++;
                }
            }

            if (tru == n) {
                break;
            } else {
                int j = a.length - 1;
                while (true) {
                    if (!b[j]) {
                        b[j] = true;
                        tru++;
                        s = a[j];
                        count++;
                        break;
                    }
                    j--;
                }
            }
        }

        out.println(count);

        out.close();
    }


    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}